<?php
/*
 * Copyright(C) 2003-2005, 2007 op5 AB
 * All rights reserved.
 *
 */

require_once('include/webconfig.inc.php');
require_once('include/config.inc.php');
require_once('include/autoscan.inc.php');
require_once('classes/common_gui.php');

//validate_user();
//html_start();
$page->html_start("Network autoscan config");
if(!in_array(NACOMA_ACCESS_FULL_ACCESS, get_nacoma_access('configuration_information'))) {
  $page->html_start();
  deny_access("You are not authorized to configure autoscans.");
}
if (!object_class::can_user_write('host', 'new')) {
  $page->html_start('');
  deny_access("You are not allowed to create new hosts.");
}


echo "<p>Network ranges can be specified in a very free form.\n" .
  "Each of the four parts of the IP-address may contain any\n" .
  "combination of comma-separated numbers, 'from-to' ranges\n" .
  "and single numbers, as such: <strong>10.1,2.0,4-10.1-50</strong>.<br />\n" .
  "You can specify multiple ranges, separated by spaces, if you like." .
  "</p>\n";
echo "<div class='note'><p>\n";
echo "<strong>Note:</strong> Only hosts responding to ICMP ECHO " .
  "requests (PING) will be detected.<br />\n";
echo "</p></div><br>\n";

$old_blacklist = autoscan_blacklist_get_list();
$new_blacklist = false;

if(isset($_REQUEST['delete']) && !empty($_REQUEST['delete'])) {
	$delscan = $_REQUEST['delete'];
	$scan_settings = autoscan_settings_get_by_id($delscan);
	$name = $scan_settings[0][4];
	echo "<b>Removing schedule scan '" . $name . "'</b>\n";
	autoscan_settings_delete($delscan);
	autoscan_result_unref_unused($delscan);
	autoscan_result_delete_nonreferecned();
	autoscan_join_delete($delscan);
}
elseif(isset($_REQUEST['action']) && $_REQUEST['action'] === 'Apply') {
	if (isset($_REQUEST['new_criteria']) && isset($_REQUEST['new_name'])) {
		if (!empty($_REQUEST['new_criteria']) && !empty($_REQUEST['new_name'])) {
			echo "<b>Add new scan '" . $_REQUEST['new_name'] . "'</b>\n";
			autoscan_settings_add($_REQUEST['new_criteria'], $_REQUEST['new_name'], $_REQUEST['new_description'], ($_REQUEST['new_enabled'] == 'on' ? 1: 0));
		} elseif (!empty($_REQUEST['new_name'])) {
			// Show warning and highlight bad fields
			echo "<b>Please, specify IP Range to scan</b>\n";
		} elseif (!empty($_REQUEST['new_criteria'])) {
			// Show warning and highlight bad fields
			echo "<b>Please, specify scan NAME</b>\n";
		}
	}

	$queries = isset($_REQUEST['criteria']) ? $_REQUEST['criteria'] : array();
	$desc = isset($_REQUEST['description']) ? $_REQUEST['description'] : array();
	$enabled = isset($_REQUEST['enabled']) ? $_REQUEST['enabled'] : array();

	foreach ($queries as $id => $value) {
		autoscan_settings_update($id, $value, $desc[$id], ($enabled[$id] == 'on' ? 1: 0));
	}

	unset($queries);
	unset($desc);
	unset($enabled);

	$new_blacklist = isset($_REQUEST['blacklist']) ? $_REQUEST['blacklist'] : array();

	if (empty($new_blacklist))
		$new_blacklist = array();

	$del_blacklist = array_diff($old_blacklist, $new_blacklist);
	foreach ($del_blacklist as $address) {
		autoscan_blacklist_delete($address);
		autoscan_result_visibility_change($address, 1);
	}

	$add_blacklist = array_diff($new_blacklist, $old_blacklist);
	foreach ($add_blacklist as $address) {
		autoscan_blacklist_add($address);
		autoscan_result_visibility_change($address, 0);
	}
}

echo "</div></div><div id=\"object-table\">\n";

$page->form_start('autoscan', 'post', $_SERVER['PHP_SELF']);
echo '<div style="width: 98%; margin-left: 1%; margin-top: -25px">';
//echo "<form method='post' action='" . $_SERVER['PHP_SELF'] . "'>\n";

echo "<a name='New scan'></a>\n";
echo "<br /><table class='max' summary=\"\"><tr><td class='CmdBar'>Host blacklist</td>\n";
echo "</tr>\n";
echo "</table><table class='max zebra' summary=\"\"style=\"border-right: 1px solid #dcdccd; border-bottom: 1px solid #dcdccd\">\n";

echo "<tr><td class='HelpList'>\n";
echo "<a style='border:0px none;' onclick=\"ShowContent('helpContent', 'autoscan_blacklist'); return false;\" tabindex='-1' title='Click to view help on autoscan_blacklist' href='#'>\n";
echo "<img title='Help' alt='Help' src='images/icons/shield-help.png'></a></td>\n";
echo "<td class='VarList'>List</td>\n";
echo "<td>\n";
echo "<select class='multiple' size='4' multiple='multiple' id='blacklist' name='blacklist[]'>\n";
echo "<optgroup label='&nbsp;Hosts'>\n";
if ($new_blacklist === false) {
	foreach ($old_blacklist as $address) {
		echo "<option value='" . $address . "'>" . $address . "</option>\n";
	}
} else {
	foreach ($new_blacklist as $address) {
		echo "<option value='" . $address . "'>" . $address . "</option>\n";
	}
}
echo "</optgroup></select>\n";
echo "</td></tr>\n";

echo "<tr><td class='HelpList'>\n";
echo "<a style='border:0px none;' onclick=\"ShowContent('helpContent', 'autoscan_blacklist_host'); return false;\" tabindex='-1' title='Click to view help on autoscan_blacklist_host' href='#'>\n";
echo "<img title='Help' alt='Help' src='images/icons/shield-help.png'></a></td>\n";
echo "<td class='VarList'>Host</td>\n";
echo "<td>\n";
echo "<input type='text' size='32' id='blacklist_host' />\n";
echo "</td></tr>\n";

echo "<tr><td class='HelpList'>\n";
echo "<a style='border:0px none;' onclick=\"ShowContent('helpContent', 'autoscan_blacklist_actions'); return false;\" tabindex='-1' title='Click to view help on autoscan_blacklist_actions' href='#'>\n";
echo "<img title='Help' alt='Help' src='images/icons/shield-help.png'></a></td>\n";
echo "<td class='VarList'>Actions</td>\n";
echo "<td>\n";
echo "<input type='button' title='Add' class='button add' value='Add' onclick=\"var blacklist = this.form.elements['blacklist'].options; var host = this.form.elements['blacklist_host'].value; var ip_addr = /^(((([0-9])|([1-9][0-9])|(1[0-9][0-9])|(2[0-4][0-9])|(25[0-5]))).){4}$/; if (ip_addr.test(host + '.')) { for (var i=0; i < blacklist.length; i++) if (blacklist[i].text == host) return; blacklist[blacklist.length] = new Option(host, host); }\">\n";
echo "<input type='button' title='Remove' class='button remove' value='Remove' onclick=\"var blacklist = this.form.elements['blacklist']; while (blacklist.selectedIndex != -1) blacklist.remove(blacklist.selectedIndex);\">\n";
echo "</td></tr>\n";

echo "</table>\n";

echo "<a name='New scan'></a>\n";
echo "<br /><table class='max' summary=\"\"><tr><td class='CmdBar'>New scan</td>\n";
echo "</tr>\n";
echo "</table><table class='max zebra' summary=\"\"style=\"border-right: 1px solid #dcdccd; border-bottom: 1px solid #dcdccd\">\n";

echo "<tr><td class='HelpList'>\n";
echo "<a style='border:0px none;' onclick=\"ShowContent('helpContent', 'autoscan_name'); return false;\" tabindex='-1' title='Click to view help on autoscan_name' href='#'>\n";
echo "<img title='Help' alt='Help' src='images/icons/shield-help.png'></a></td>\n";
echo "<td class='VarList'>Name</td>\n";
echo "<td>\n";
echo "<input type='text' size='32' name='new_name' />\n";
echo "</td></tr>\n";

echo "<tr><td class='HelpList'>\n";
echo "<a style='border:0px none;' onclick=\"ShowContent('helpContent', 'autoscan_range'); return false;\" tabindex='-1' title='Click to view help on autoscan_range' href='#'>\n";
echo "<img title='Help' alt='Help' src='images/icons/shield-help.png'></a></td>\n";
echo "<td class='VarList'>IP Range</td>\n";
echo "<td>\n";
echo "<input type='text' size='32' name='new_criteria' />\n";
echo "</td></tr>\n";

echo "<tr><td class='HelpList'>\n";
echo "<a style='border:0px none;' onclick=\"ShowContent('helpContent', 'autoscan_desc'); return false;\" tabindex='-1' title='Click to view help on autoscan_desc' href='#'>\n";
echo "<img title='Help' alt='Help' src='images/icons/shield-help.png'></a></td>\n";
echo "<td class='VarList'>Description</td>\n";
echo "<td>\n";
echo "<textarea name='new_description' rows='5' cols='41'></textarea>\n";
echo "</td></tr>\n";

echo "<tr><td class='HelpList'>\n";
echo "<a style='border:0px none;' onclick=\"ShowContent('helpContent', 'autoscan_enabled'); return false;\" tabindex='-1' title='Click to view help autoscan_enabled' href='#'>\n";
echo "<img title='Help' alt='Help' src='images/icons/shield-help.png'></a></td>\n";
echo "<td class='VarList'>Active</td>\n";
echo "<td>\n";
echo "<input type='checkbox' name='new_enabled' checked='checked' />\n";
echo "</td></tr>\n";

echo "</table>\n";

//SELECT id, count, epoch, criteria, name, description, enabled FROM autoscan_settings
$list = autoscan_settings_get_list();
foreach ($list as $row) {
	$scan_id = $row[0];
	$scan_criteria = $row[3];
	$scan_name = $row[4];
	$scan_desc = $row[5];
	$scan_enabled = $row[6];
	echo "<a name='" . $row[4] . "'></a>\n";

	// one table around it all, and the one we are inside.
	echo "<br /><table class='max' summary=\"\"><tr><td class='CmdBar'>\n";
	echo $scan_name . "\n";
	echo "</td>\n";

	echo "<td class='CmdBarItem'>\n";
	echo "<a href='$_SERVER[PHP_SELF]?delete=" . $scan_id . "'>delete</a></td>\n";

	echo "</tr>\n";
	echo "</table><table class='max zebra' summary=\"\"style=\"border-right: 1px solid #dcdccd; border-bottom: 1px solid #dcdccd\">\n";

	echo "<tr><td class='HelpList'>\n";
	echo "<a style='border:0px none;' onclick=\"ShowContent('helpContent', 'autoscan_range'); return false;\" tabindex='-1' title='Click to view help on timeperiod_name' href='#'>\n";
	echo "<img title='Help' alt='Help' src='images/icons/shield-help.png'></a></td>\n";
	echo "<td class='VarList'>IP Range</td>\n";
	echo "<td>\n";
	echo "<input type='text' size='32' name='criteria[" . $scan_id . "]' value='" . $scan_criteria . "' />\n";
	echo "</td></tr>\n";

	echo "<tr><td class='HelpList'>\n";
	echo "<a style='border:0px none;' onclick=\"ShowContent('helpContent', 'autoscan_desc'); return false;\" tabindex='-1' title='Click to view help on timeperiod_name' href='#'>\n";
	echo "<img title='Help' alt='Help' src='images/icons/shield-help.png'></a></td>\n";
	echo "<td class='VarList'>Description</td>\n";
	echo "<td>\n";
	echo "<textarea name='description[" . $scan_id . "]' rows='5' cols='41'>" . $scan_desc . "</textarea>\n";
	echo "</td></tr>\n";

	echo "<tr><td class='HelpList'>\n";
	echo "<a style='border:0px none;' onclick=\"ShowContent('helpContent', 'autoscan_enabled'); return false;\" tabindex='-1' title='Click to view help on timeperiod_name' href='#'>\n";
	echo "<img title='Help' alt='Help' src='images/icons/shield-help.png'></a></td>\n";
	echo "<td class='VarList'>Active</td>\n";
	echo "<td>\n";
	echo "<input type='checkbox' name='enabled[" . $scan_id . "]'";
	if($scan_enabled)
		echo " checked='checked'";
	echo " /></td></tr>\n";

	echo "</table>\n";
}
unset($result);
echo '<table>';
$page->submit_button('Apply');
echo '</table>';
echo '</div>';
$page->form_end();
$page->html_end();
